commit 0dd533da49cf15aa9afd35634ba4bd80e9c96565
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Thu Jan 6 09:29:34 2022

    ifcvt: Check for asm goto at the end of then_bb/else_bb in ifcvt [PR103908]
    
    On the following testcase, RTL ifcvt sees then_bb
    (note 7 6 8 3 [bb 3] NOTE_INSN_BASIC_BLOCK)
    (insn 8 7 9 3 (set (mem/c:SI (symbol_ref:DI ("b") [flags 0x2]  <var_decl 0x7fdccf5b0cf0 b>) [1 b+0 S4 A32])
            (const_int 1 [0x1])) "pr103908.c":6:7 81 {*movsi_internal}
         (nil))
    (jump_insn 9 8 13 3 (parallel [
                (asm_operands/v ("# insn 1") ("") 0 []
                     []
                     [
                        (label_ref:DI 21)
                    ] pr103908.c:7)
                (clobber (reg:CC 17 flags))
            ]) "pr103908.c":7:5 -1
         (expr_list:REG_UNUSED (reg:CC 17 flags)
            (nil))
     -> 21)
    and similarly else_bb (just with a different asm_operands template).
    It checks that those basic blocks have a single successor and
    uses last_active_insn which intentionally skips over JUMP_INSNs, sees
    both basic blocks contain the same set and merges them (or if the
    sets are different, attempts some other noce optimization).
    But we can't assume that the jump, even when it has only a single successor,
    has no side-effects.
    
    The following patch fixes it by punting if test_bb ends with a JUMP_INSN
    that isn't onlyjump_p.
    
    2022-01-06  Jakub Jelinek  <jakub@redhat.com>
    
            PR rtl-optimization/103908
            * ifcvt.c (bb_valid_for_noce_process_p): Punt on bbs ending with
            asm goto.
    
            * gcc.target/i386/pr103908.c: New test.
    
    (cherry picked from commit 80ad67e2af0620d58d57d0406dc22693cf5b8ca9)

diff --git a/gcc/ifcvt.c b/gcc/ifcvt.c
index 1ac0c160266..2d98cc2a35a 100644
--- a/gcc/ifcvt.c
+++ b/gcc/ifcvt.c
@@ -3064,6 +3064,12 @@ bb_valid_for_noce_process_p (basic_block test_bb, rtx cond,
 
   if (!insn_valid_noce_process_p (last_insn, cc))
     return false;
+
+  /* Punt on blocks ending with asm goto or jumps with other side-effects,
+     last_active_insn ignores JUMP_INSNs.  */
+  if (JUMP_P (BB_END (test_bb)) && !onlyjump_p (BB_END (test_bb)))
+    return false;
+
   last_set = single_set (last_insn);
 
   rtx x = SET_DEST (last_set);
diff --git a/gcc/testsuite/gcc.target/i386/pr103908.c b/gcc/testsuite/gcc.target/i386/pr103908.c
new file mode 100644
index 00000000000..7c57e1ddf6a
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr103908.c
@@ -0,0 +1,24 @@
+/* PR rtl-optimization/103908 */
+/* { dg-do compile } */
+/* { dg-options "-O1 -fdisable-tree-cselim -fno-tree-sink" } */
+/* { dg-final { scan-assembler "# insn 1" } } */
+/* { dg-final { scan-assembler "# insn 2" } } */
+
+int a, b;
+
+void
+foo (void)
+{
+  if (a)
+    {
+      b = 1;
+      asm goto ("# insn 1" : : : : lab1);
+    lab1:;
+    }
+  else
+    {
+      b = 1;
+      asm goto ("# insn 2" : : : : lab2);
+    lab2:;
+    }
+}

